using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using System.Collections;

namespace PlugInLib
{
    /// <summary>
    /// Dynamic Event Handling Using Reflection
    /// Kerry Wong
    /// http://www.kerrywong.com
    /// </summary>
    public class PlugIn : PlugInInterface.PlugInInterface 
    {
        private Hashtable _ht;
        public event PlugInInterface.ProgressChangedDelegate ProgressChanged;

        public Hashtable Hash
        {
            get {return _ht;}
            set {_ht = value;}
        }

        public PlugIn()
        {
            _ht = new Hashtable();
            _ht["Key"] = "Value";
        }

        public void Test()
        {
            if (ProgressChanged != null)
            {
                ProgressChanged("start");
            }

            Console.WriteLine(_ht["Key"].ToString());

            if (ProgressChanged != null)
            {
                ProgressChanged("done!");
            }
        }
    }
}
